﻿Type=Activity
Version=3.5
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	Private ast2 As AsyncStreams
	Private ast As AsyncStreamsText
	Private qrcodebmp As Bitmap
	Dim serial2 As Serial
	Dim SQL1 As SQL
	Dim Cursor1 As Cursor
	Dim cr As String = Chr(13) & Chr(10)
	Dim DBFileName As String										: DBFileName = "test1.db"
	Dim DBFilePath As String										: DBFilePath = File.DirInternal
	Dim DBTableName As String										: DBTableName = "Table1"
	Dim Timer1 As Timer
End Sub

Sub Globals
	Dim txtInput As EditText
	Dim txtLog As EditText
	Dim btnSend As Button
	Dim pnl1 As Panel
	Dim btnQRcode As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("2")
	Activity.Title = "Citizen CMP-20 Activity"
	serial2 =  Main.serial1
	If ast.IsInitialized = False Then
		ast.Initialize(Me, "ast", serial2.InputStream, serial2.OutputStream) 
		
	End If
	If ast2.IsInitialized = False Then
		ast2.Initialize(serial2.InputStream, serial2.OutputStream,"ast2")
	End If
	txtLog.Width = 100%x
	If File.Exists(DBFilePath, DBFileName) = False Then
		If FirstTime Then 
			If File.Exists(File.DirAssets, DBFileName) = True Then
				File.Copy(File.DirAssets, DBFileName, DBFilePath, DBFileName)
				SQL1.Initialize(DBFilePath, DBFileName, True)
				SQLTableCreate
				SQLTableFill
			Else
				SQL1.Initialize(DBFilePath, DBFileName, True)
				SQLTableCreate
				SQLTableFill
			End If
		End If
	Else
		If FirstTime Then 
			SQL1.Initialize(DBFilePath, DBFileName, True)
			SQLTableCreate
			SQLTableFill
		End If
	End If
End Sub


Sub ast_Error
	ToastMessageShow("Connection is broken.", True)
	btnSend.Enabled = False
	txtInput.Enabled = False
End Sub


Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		ast.Close
		Cursor1.Close	
	End If
End Sub

Sub txtInput_EnterPressed
	If btnSend.Enabled = True Then btnSend_Click
End Sub
Sub btnSend_Click
	Dim su As StringUtils
 	Dim s As String="my name"&CRLF&"123456"
	
	Log(s)
	ast.Write("First Test")
	LogMessage("Me", "Drucken...")
End Sub

Sub LogMessage(From As String, Msg As String)
	txtLog.Text = txtLog.Text & From & ": " & Msg & CRLF
	txtLog.SelectionStart = txtLog.Text.Length
End Sub
Sub Prn_test2
	Log("Vor btConn")
	'CMP20.printSetup(Main.connectedDevice.Mac)
	Log("Nach btConn")
End Sub
Sub ast_NewText(Text As String)    
	Log("Text: " & Text)    
	Log(Text.Length)
End Sub
Sub ast_Terminated    
	Log("Connection terminated")
End Sub
Sub ast2_Error
	ToastMessageShow("Connection is broken.", True)
	btnSend.Enabled = False
	txtInput.Enabled = False
End Sub
Sub ast2_NewText(Text As String)    
	Log("Text: " & Text)    
	Log(Text.Length)
End Sub

Sub btnQRcode_Click
	
	ast.Write(" ")
	Timer1.Initialize("Timer1",2000)
	Timer1.Enabled = True
		
End Sub

Sub Timer1_Tick
	Timer1.Enabled = False
	PrintExample
End Sub

Sub SQLTableCreate
	Dim i As Int
	Dim txt As String
	
	SQL1.ExecNonQuery("DROP TABLE IF EXISTS "& DBTableName) 'TEST is you table
	
	txt = "CREATE TABLE " & DBTableName & " (_id INTEGER PRIMARY KEY AUTOINCREMENT, lastname VARCHAR(30) NULL , firstname VARCHAR(30) NULL, taxiprice VARCHAR(10) NULL)"
	SQL1.ExecNonQuery(txt)
End Sub

Sub SQLTableFill
' Fills a SQL data base
	Dim i As Int
	Dim txt1 As String
	
	SQL1.BeginTransaction
	Try
		For i = 1 To 2
			txt1 = "INSERT INTO " & DBTableName & " (lastname, firstname, taxiprice) VALUES ('Lastname" & i & "', 'Firstname" & i & "', '" & (i * 33) & "')"
			SQL1.ExecNonQuery(txt1)
		Next
		SQL1.TransactionSuccessful
	Catch
		Log(LastException.Message)
	End Try
	SQL1.EndTransaction
End Sub



Sub SQLTableRead
' Reads the SQL data base
	Dim i As Int
	Dim txt, wtxt As String

	txt = "SELECT * FROM " & DBTableName 

		
	Cursor1 = SQL1.ExecQuery(txt)
	
	
End Sub

Sub PrintExample
	Dim ESC As Char
	Dim Normal As String
	Dim Boldon As String
	Dim Boldoff As String
   	Dim Singleon As String
	Dim DoubleWideon As String
   	Dim DoubleHighon As String
   	Dim DoubleWideHighon As String
   	Dim UnderLineon As String
	Dim Singleoff As String
	Dim DoubleWideoff As String
   	Dim DoubleHighoff As String
   	Dim DoubleWideHighoff As String
   	Dim UnderLineoff As String
	Dim Center As String
	Dim Right As String
	Dim Left As String
	
	Dim PrintBuffer As String
	
	ESC = Chr(27)
	Normal 		  	  = ESC & Chr(64) '"|N" 
   	Singleon 		  = ESC & Chr(33) & Chr(8) '"|1C"
	Singleoff 		  = ESC & Chr(33) & Chr(0) '"|1C"
	DoubleHighon 	  = ESC & Chr(33) & Chr(16) '"|1C"
	DoubleHighoff 	  = ESC & Chr(33) & Chr(0) '"|1C"
	DoubleWideon 	  = ESC & Chr(33) & Chr(32) '"|2C"
   	DoubleWideoff 	  = ESC & Chr(33) & Chr(0) '"|2C"
   	DoubleWideHighon  = ESC & Chr(33) & Chr(64) '"|4C"
	DoubleWideHighoff = ESC & Chr(33) & Chr(0) '"|4C"
	UnderLineon		  = ESC & Chr(33) & Chr(128) '"|uC"
	UnderLineoff	  = ESC & Chr(33) & Chr(0) '"|uC"
	Left   			  = ESC & Chr(97) & Chr(0)  '"|lA"
	Center 			  = ESC & Chr(97) & Chr(1)  '"|cA"
	Right  			  = ESC & Chr(97) & Chr(2)  '"|rA"
	Boldon  	      = ESC & Chr(71) & Chr(1)   '"|bC"
	Boldoff 		  = ESC & Chr(71) & Chr(0)  '"!bC"	
	
	
	SQLTableRead
	
		
	If Cursor1.IsInitialized = True Then
		For i = 0 To Cursor1.RowCount - 1
			Cursor1.Position = i
			PrintBuffer = Center & DoubleHighon & Boldon & "Taxi-Receipt" & Boldoff & DoubleHighoff & cr & cr
			PrintBuffer = PrintBuffer & Cursor1.GetString("firstname") & " " & Cursor1.GetString("lastname") & cr
			PrintBuffer = PrintBuffer & "____________________" & cr
			PrintBuffer = PrintBuffer & "Drive a to b = " & Cursor1.GetString("taxiprice") & cr  'New field in table
			PrintBuffer = PrintBuffer & "--------------------" & cr & cr
			ast.Write(PrintBuffer) ' Print 1 row for each tablerow
		Next
	End If
	ast.Write(cr & cr & cr) 'Print 3 lines

End Sub